#if !defined(AFX_DISPLAYCOM_H__20080118_D283_02DF_A968_0080AD509054__INCLUDED_)
#define AFX_DISPLAYCOM_H__20080118_D283_02DF_A968_0080AD509054__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Thread.h"

#include <msxml2.h>

#define REG_SETTINGS_KEY "SOFTWARE\\Viksoe.dk\\LedDisplaySideShow"


class CDisplayLink : public CThreadImpl<CDisplayLink, CThreadStopAtEvent>
{
public:
   CContentManager* m_pContent;      // Content manager
   int m_iPos;                       // Index in content manager's list
/*   TCHAR m_szIPAddress[30];          // IP address of LED Display
   DWORD m_dwIPPort;                 // IP port of LED Display
*/
   DWORD m_dwSleep;                  // Idle time between changing content
   //CSocket m_Socket;                 // TCP/IP connection to LED Display hardware
   HANDLE hCom;
   DWORD m_dwConnectTick;            // Timestamp for last connect attempt

   CDisplayLink() : m_pContent(NULL), m_iPos(0), /*m_dwIPPort(0),*/ m_dwSleep(1000), hCom(INVALID_HANDLE_VALUE)
   {
      DRVTRACE(_T("CDisplayLink\n"));
//      memset(m_szIPAddress, 0, sizeof(m_szIPAddress));
      m_dwConnectTick = 0;
   }
   ~CDisplayLink()
   {
      DRVTRACE(_T("~CDisplayLink\n"));
   }

   void Init(CContentManager* pContentManager)
   {
      m_pContent = pContentManager;
   }

   void ProcessContent(LPWSTR pstrData)
   {
//      DRVTRACE(_T("Displaying: \"%ls\"\n"), DbgGetStringBuffer(Info.wszText));
      // This is a simple function that strips all HTML tags, looks out for <txt>
      // tags and copy only data inside these tags.
      LPWSTR pstrDest = pstrData;
      bool bInsideTag = false;
      bool bIsText = false;
      int nSpaces = 0;
      while( *pstrData != '\0' ) 
      {
         if( *pstrData == '<' ) {
            if( bIsText && wcsncmp(pstrData, L"<br", 3 ) == 0 ) *pstrDest++ = '\n';
            nSpaces = 0;
            bInsideTag = true;
            if( wcsncmp(pstrData, L"<txt", 4) == 0 ) bIsText = true;
			if( wcsncmp(pstrData, L"</txt", 5) == 0 ) {
				bIsText = false;
				*pstrDest++ = '\n';
			}
         }
         if( bInsideTag ) {
            if( *pstrData == '>' ) bInsideTag = false;
            pstrData++;
            continue;
         }
         if( bIsText ) {
            switch( *pstrData ) {
            case ' ':
            case '\n':
            case '\r':
               *pstrDest = ' ';
               if( ++nSpaces == 1 ) pstrDest++;
               break;
            default:
               *pstrDest = *pstrData;
               pstrDest++;
               nSpaces = 0;
               break;
            }
         }
         pstrData++;
      }
      *pstrDest = '\0';
   }

   DWORD Run()
   {
      ATLASSERT(m_pContent);

      ::CoInitialize(NULL);

//      WSAInit ipinit;

//      if( !_LoadSettings() ) return 0;

      _Connect();

      while( !IsAborted() )
      {
         // Wait for stop-event but update display at select intervals
         if( ::WaitForSingleObject(m_hStopEvent, m_dwSleep) != WAIT_TIMEOUT ) break;

//         if( m_Socket.IsNull() ) _Connect();
         if( hCom==INVALID_HANDLE_VALUE ) _Connect();

         CONTENTINFO Info;
         BOOL bRes;
         // Thread-lock
         {
            CLockStaticDataInit lock;
            int nCount = m_pContent->GetSize();
            if( nCount == 0 ) continue;
            m_iPos = (m_iPos + 1) % nCount;
            bRes = m_pContent->GetInfoAt(m_iPos, Info);
         }
         if( !bRes ) continue;

         _DisplayContent(Info);
      }

      _Disconnect();

      ::CoUninitialize();
      return 0;
   }
/*
   bool _LoadSettings()
   {
      DRVTRACE(_T("CDisplayLink::LoadSettings\n"));
      CRegKey reg;
      if( ERROR_SUCCESS != reg.Open(HKEY_LOCAL_MACHINE, _T(REG_SETTINGS_KEY), KEY_READ) ) return false;
      DWORD dwSize = sizeof(m_szIPAddress);
      reg.QueryValue(m_szIPAddress, _T("IP Address"), &dwSize);
      reg.QueryValue(m_dwIPPort, _T("IP Port"));
      reg.QueryValue(m_dwSleep, _T("Sleep"));
      reg.Close();
      DRVTRACE(_T("  IP Address: %s\n"), m_szIPAddress);
      DRVTRACE(_T("  IP Port: %ld\n"), m_dwIPPort);
      DRVTRACE(_T("  Sleep: %ld ms\n"), m_dwSleep);
      return true;
   }
*/
   void _Send(const char * lpBuffer, DWORD nNumberOfBytesToWrite, boolean wait=true)
   {
//DRVTRACE(_T ( "_Send(,%i\n"), nNumberOfBytesToWrite);
	    DWORD NumberOfBytesRead;
		if (!WriteFile(hCom, lpBuffer, nNumberOfBytesToWrite, &NumberOfBytesRead, NULL)) {
			DRVTRACE(_T ( "!WriteFile"));
		}

	if(wait) {
		DWORD dwBytesRead = 0;
		char ReadBuffer[1] = {0};
		int i=0;
		//while (dwBytesRead==0 && i<1000) {
			if (!ReadFile(hCom, &ReadBuffer, 1, &dwBytesRead, 0)) {
				DRVTRACE(_T ( "!ReadFile"));
			}
			/*Sleep(1);
			i++;
		}*/
		if (dwBytesRead==0) {
			DRVTRACE(_T ( "dwBytesRead==0!\n"));
		} else {
			if (ReadBuffer[0]==0x15) DRVTRACE(_T ( "NACK!"));
			else if (ReadBuffer[0]==0) DRVTRACE(_T ( "ReadBuffer[0]==0"));
			else if (ReadBuffer[0]!=6) DRVTRACE(_T ( "!ACK"));
		}
	 }
   }

   bool _Connect()
   {
// Attempt only reconnect every 60sec (don't flood logfile)
      const DWORD ONE_MINUTE = 60000;
      DWORD dwBefore = m_dwConnectTick / ONE_MINUTE;
      m_dwConnectTick = ::GetTickCount();
      DWORD dwNow = m_dwConnectTick / ONE_MINUTE;
      if( dwBefore == dwNow ) return false;

//      DRVTRACE(_T("CDisplayLink::Connect  %s:%ld\n"), m_szIPAddress, m_dwIPPort);
      DRVTRACE(_T("CDisplayLink::Connect 4\n"));

/*      if( !m_Socket.Open( (WORD) m_dwIPPort, m_szIPAddress) ) {
         DRVTRACE(_T("ERROR: Failed to connect to LED display!\n"));
         return false;
      }
*/








   DCB dcb;
   BOOL fSuccess;
   TCHAR *pcCommPort = TEXT("COM4");

   hCom = CreateFile( pcCommPort,
                    GENERIC_READ | GENERIC_WRITE,
                    0,    // must be opened with exclusive-access
                    NULL, // default security attributes
                    OPEN_EXISTING, // must use OPEN_EXISTING
                    0,    // not overlapped I/O
                    NULL  // hTemplate must be NULL for comm devices
                    );

   if (hCom == INVALID_HANDLE_VALUE) 
   {
       // Handle the error.
       DRVTRACE(_T ("CDisplayLink::CreateFile failed with error %d.\n"), GetLastError());
       return false;
   }

   // Build on the current configuration, and skip setting the size
   // of the input and output buffers with SetupComm.

   SecureZeroMemory(&dcb, sizeof(DCB));
   dcb.DCBlength = sizeof(DCB);
   fSuccess = GetCommState(hCom, &dcb);

   if (!fSuccess) 
   {
      // Handle the error.
      DRVTRACE(_T ("CDisplayLink::GetCommState failed with error %d.\n"), GetLastError());
      return false;
   }

   // Fill in DCB: 115,200 bps, 8 data bits, no parity, and 1 stop bit.

   dcb.BaudRate = CBR_115200;     // set the baud rate
   dcb. fParity = false;
   dcb.fOutxCtsFlow = false;
   dcb.fOutxDsrFlow = false;
   dcb.fDtrControl = DTR_CONTROL_DISABLE;
   dcb.fDsrSensitivity = false;
   dcb.fOutX = false;
   dcb.fInX = false;
   dcb.fNull = false;
   dcb.fRtsControl = RTS_CONTROL_DISABLE;
   dcb.ByteSize = 8;             // data size, xmit, and rcv
   dcb.Parity = NOPARITY;        // no parity bit
   dcb.StopBits = ONESTOPBIT;    // one stop bit

   fSuccess = SetCommState(hCom, &dcb);

   if (!fSuccess) 
   {
      // Handle the error.
      DRVTRACE(_T ("CDisplayLink::SetCommState failed with error %d.\n"), GetLastError());
      return false;
   }

   DRVTRACE(_T ("CDisplayLink::Serial port %s successfully reconfigured.\n"), pcCommPort);

	//now set the timeouts
	COMMTIMEOUTS timeouts;
	
	timeouts.ReadIntervalTimeout			= MAXDWORD; 
	timeouts.ReadTotalTimeoutMultiplier		= MAXDWORD;
	timeouts.ReadTotalTimeoutConstant		= 500;
	timeouts.WriteTotalTimeoutMultiplier	= 0;
	timeouts.WriteTotalTimeoutConstant		= 0;

	if (!SetCommTimeouts(hCom, &timeouts))
	{
		DRVTRACE(_T ( "CDisplayLink::Error setting time-outs. %d"),GetLastError());
		return false;
	}

	DRVTRACE(_T ("CDisplayLink::Timeouts successfully reconfigured.\n"));



	char aUtobaud[] = { 'U' };
    _Send(aUtobaud, sizeof(aUtobaud), true);

	/*char Erase[] = { 'E' };
    _Send(Erase, sizeof(Erase), true);

	char Opaque[] = { 'O', 1 };
    _Send(Opaque, sizeof(Opaque), true);*/

	char powerUp[] = { 'Y', 3, 1 };
    _Send(powerUp, sizeof(powerUp));

	char displaYcontrol[] = { 'Y', 4, 1 };
    _Send(displaYcontrol, sizeof(displaYcontrol), true);










/*      LINGER lingerInfo;
      lingerInfo.l_onoff = 1;
      lingerInfo.l_linger = 0;
      int timeout = 1000;
      ::setsockopt(m_Socket, SOL_SOCKET, SO_LINGER, (char *) &lingerInfo, sizeof(lingerInfo));
      ::setsockopt(m_Socket, SOL_SOCKET, SO_SNDTIMEO, (char*) &timeout, sizeof(timeout));
*/
      DRVTRACE(_T("CDisplayLink::Connect - OK\n"));
      return true;
   }

   bool _DisplayContent(const CONTENTINFO& Info)
   {
      USES_CONVERSION;

//      if( m_Socket.IsNull() ) return false;
	  if( hCom==INVALID_HANDLE_VALUE ) return false;

      DRVTRACE(_T("CDisplayLink::Displaying: \"%ls\"\n"), DbgGetStringBuffer(Info.wszText));

	char Erase[] = { 'E' };
    _Send(Erase, sizeof(Erase), true);

	char text_preamble[] = {
/*            0x0F // Initiate address mode
          , 0x20 // Add address of unit to this
          , 0x0E // Terminate address mode
          ,*/'s' // Initiate text mode    
          , 0, 0, /*0*/3, 0x07, 0xE0 // Add buffer pos here (eg. to start writing at char pos 5, this must be 0x25)
          //, 0x00
      };

      char text_postamble[] = {    
/*            0x03 // Terminate text mode
          , 0x09 // Terminate comms
          ,*/ 0x00
      };









/*
      LPSTR pstrData = W2A(Info.wszText);
      bool bInsideTag = false;
      bool bIsText = false;
      int nSpaces = 0;
      while( *pstrData != '\0' ) 
      {
         if( *pstrData == '<' ) {
            if( bIsText && strncmp(pstrData, "<br", 3 ) == 0 ) *pstrDest++ = ' ';
            nSpaces = 0;
            bInsideTag = true;
            if( strncmp(pstrData, "<txt", 4) == 0 ) bIsText = true;
            if( strncmp(pstrData, "</txt", 5) == 0 ) bIsText = false;
         }
         if( bInsideTag ) {
            if( *pstrData == '>' ) bInsideTag = false;
            pstrData++;
            continue;
         }
         if( bIsText ) {
            switch( *pstrData ) {
            case ' ':
            case '\n':
            case '\r':
               *pstrDest = ' ';
               if( ++nSpaces == 1 ) pstrDest++;
               break;
            default:
               *pstrDest = *pstrData;
               pstrDest++;
               nSpaces = 0;
               break;
            }
         }
         pstrData++;
      }
      *pstrDest = '\0';
*/













#define MAX_LINES 15
#define MAX_CHARS 26

      CHAR szLines[MAX_LINES][MAX_CHARS];
      memset(szLines, ' ', sizeof(szLines));

      LPSTR pstr = W2A(Info.wszText);
	  LPBYTE pDest = (LPBYTE) szLines;
      int cbSize = (int) strlen(pstr);
      for( int i = 0; cbSize > 0 && i < MAX_LINES; i++ ) {
//         SIZE_T cData = min(cbSize, MAX_CHARS);
         DWORD cData = min(cbSize, MAX_CHARS);
         memcpy(pDest, pstr, cData);
         pDest += MAX_CHARS;
         pstr += cData;
         cbSize -= cData;
      }

/*      if( !m_Socket.Write(&text_preamble, sizeof(text_preamble)) ) {
         DRVTRACE(_T("ERROR: Send failed (1)\n"));
         m_Socket.Close();
         return false;
      }
*/
	 /*char Erase[] = { 'E' };
	 _Send(Erase, sizeof(Erase));*/
	  for( int j = 0; j < MAX_LINES; j++ ) {
         LPSTR pstr = szLines[j];
         CHAR szOut[MAX_CHARS] = { 0 };
         ::CharToOemBuffA(pstr, szOut, MAX_CHARS);
/*         if( !m_Socket.Write(szOut, MAX_CHARS) ) {
            DRVTRACE(_T("ERROR: Send failed (2)\n"));
            m_Socket.Close();
            return false;
         }
*/
		 text_preamble[2]=j;
		 _Send(text_preamble, sizeof(text_preamble), false);
		 _Send(szOut, MAX_CHARS, false);
		 _Send(text_postamble, sizeof(text_postamble), true);
		 
      }
/*      if( !m_Socket.Write(&text_postamble, sizeof(text_postamble)) ) {
         DRVTRACE(_T("ERROR: Send failed (3)\n"));
         m_Socket.Close();
         return false;
      }
*/   
      return true;
   }

   void _Disconnect()
   {
      DRVTRACE(_T("CDisplayLink::Disconnect\n"));
//      m_Socket.Close();
	char powerDown[] = { 'Y', 3, 0 };
    _Send(powerDown, sizeof(powerDown));
	  CloseHandle(hCom);
	  hCom=INVALID_HANDLE_VALUE;
      DRVTRACE(_T("CDisplayLink::Disconnected\n"));
   }
};


#endif // !defined(AFX_DISPLAYCOM_H__20080118_D283_02DF_A968_0080AD509054__INCLUDED_)
