#if !defined(AFX_DRIVERHELPER_H__20080118_78F7_DF83_A37C_0080AD509054__INCLUDED_)
#define AFX_DRIVERHELPER_H__20080118_78F7_DF83_A37C_0080AD509054__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


/////////////////////////////////////////////////////////////////////////////
// Application Manager

typedef struct tagAPPINFO {
   SID user;
   APPLICATION_ID AppId;
   ENDPOINT_ID EndPoint;
   WCHAR wszName[80];
   DWORD cachePolicy;
   DWORD dwOnlineOnly;
} APPINFO;


class CAppManager
{
public:
   BOOL Add(APPINFO Info)
   {
      Remove(Info.AppId);
      return m_aApps.Add(Info);
   }
   BOOL Remove(REFAPPLICATION_ID rAppId)
   {
      for( int i = 0; i < m_aApps.GetSize(); i++ ) {
         if( memcmp(&m_aApps[i].AppId, &rAppId, sizeof(GUID)) == 0 ) return m_aApps.RemoveAt(i);
      }
      return FALSE;
   }
   void RemoveAll()
   {
      while( m_aApps.GetSize() > 0 ) m_aApps.RemoveAt(0);
   }
   BOOL GetInfo(REFAPPLICATION_ID rAppId, APPINFO& Info) const
   {
      for( int i = 0; i < m_aApps.GetSize(); i++ ) {
         if( memcmp(&m_aApps[i].AppId, &rAppId, sizeof(GUID)) == 0 ) {
            Info = m_aApps[i];
            return TRUE;
         }
      }
      return FALSE;
   }
   BOOL GetInfoAt(int iIndex, APPINFO& Info) const
   {
      if( iIndex < 0 || iIndex >= m_aApps.GetSize() ) return FALSE;
      Info = m_aApps[iIndex];
      return TRUE;
   }
   int GetSize() const
   {
      return m_aApps.GetSize();
   }

   LPCWSTR DbgPrintName(REFAPPLICATION_ID rAppId) const
   {
      static APPINFO Info;
      if( !GetInfo(rAppId, Info) ) return L"";
      return Info.wszName;
   }

   CSimpleArray<APPINFO> m_aApps;
};


/////////////////////////////////////////////////////////////////////////////
// Content Manager

typedef struct tagCONTENTINFO {
   SID user;
   APPLICATION_ID AppId;
   ENDPOINT_ID RendererId;
   CONTENT_ID ContentId;
   WCHAR wszText[400];
} CONTENTINFO;


class CContentManager
{
public:
   BOOL Add(CONTENTINFO Info)
   {
      Remove(Info.AppId, Info.RendererId, Info.ContentId);
      return m_aItems.Add(Info);
   }
   BOOL Remove(REFAPPLICATION_ID rAppId, REFENDPOINT_ID rRendererId, const CONTENT_ID contentId)
   {
      for( int i = 0; i < m_aItems.GetSize(); i++ ) {
         if( memcmp(&m_aItems[i].AppId, &rAppId, sizeof(GUID)) == 0 
             && memcmp(&m_aItems[i].RendererId, &rRendererId, sizeof(GUID)) == 0 
             && m_aItems[i].ContentId == contentId ) 
         {
            return m_aItems.RemoveAt(i);
         }
      }
      return FALSE;
   }
   void RemoveApplication(REFAPPLICATION_ID rAppId)
   {
      for( int i = 0; i < m_aItems.GetSize(); i++ ) {
         if( memcmp(&m_aItems[i].AppId, &rAppId, sizeof(GUID)) == 0 ) {
            m_aItems.RemoveAt(i);
            i = -1;
         }
      }
   }
   void RemoveAll()
   {
      while( m_aItems.GetSize() > 0 ) m_aItems.RemoveAt(0);
   }
   BOOL GetInfo(REFAPPLICATION_ID rAppId, REFENDPOINT_ID rRendererId, const CONTENT_ID contentId, CONTENTINFO& Info) const
   {
      for( int i = 0; i < m_aItems.GetSize(); i++ ) {
         if( memcmp(&m_aItems[i].AppId, &rAppId, sizeof(GUID)) == 0 
             && memcmp(&m_aItems[i].RendererId, &rRendererId, sizeof(GUID)) == 0 
             && m_aItems[i].ContentId == contentId ) 
         {
            Info = m_aItems[i];
            return TRUE;
         }
      }
      return FALSE;
   }
   BOOL GetInfoAt(int iIndex, CONTENTINFO& Info) const
   {
      if( iIndex < 0 || iIndex >= m_aItems.GetSize() ) return FALSE;
      Info = m_aItems[iIndex];
      return TRUE;
   }
   int GetSize() const
   {
      return m_aItems.GetSize();
   }

   CSimpleArray<CONTENTINFO> m_aItems;
};



#endif // !defined(AFX_DRIVERHELPER_H__20080118_78F7_DF83_A37C_0080AD509054__INCLUDED_)

