// LedSideShowDriver.cpp : Implementation of DLL Exports.
// Modified from http://viksoe.dk/code/ledsideshow.htm by Sven Killig <sven@killig.de>

#include "stdafx.h"
#include "resource.h"

#include <initguid.h>

#include "DriverEntry.h"


// F0457B4A-6458-494E-A9F1-D4A5537D829A
const CLSID CLSID_DriverEntry = {0xF0457B4B,0x6458,0x494E,{0xA9,0xF1,0xD4,0xA5,0x53,0x7D,0x82,0x9A}};


// You can safely remove these if your WDK doesn't hate you
// as much as it hates me.
class DECLSPEC_UUID("76EFD608-E0CE-4887-98E2-F931363C4BC5") SideShowClassExtension;
const CLSID CLSID_SideShowClassExtension = __uuidof(SideShowClassExtension);
DEFINE_GUID(SIDESHOW_ENDPOINT_SIMPLE_CONTENT_FORMAT,    0xa9a5353f, 0x2d4b, 0x47ce, 0x93, 0xee, 0x75, 0x9f, 0x3a, 0x7d, 0xda, 0x4f);
DEFINE_PROPERTYKEY( WPD_PROPERTY_COMMON_COMMAND_ID ,        0xF0422A9C, 0x5DC8, 0x4440, 0xB5, 0xBD, 0x5D, 0xF2, 0x88, 0x35, 0x65, 0x8A , 1002 );
DEFINE_PROPERTYKEY( WPD_PROPERTY_COMMON_COMMAND_CATEGORY ,  0xF0422A9C, 0x5DC8, 0x4440, 0xB5, 0xBD, 0x5D, 0xF2, 0x88, 0x35, 0x65, 0x8A , 1001 ); 


CComModule _Module;

BEGIN_OBJECT_MAP(ObjectMap)
OBJECT_ENTRY(CLSID_DriverEntry, CDriverEntry)
END_OBJECT_MAP()



/////////////////////////////////////////////////////////////////////////////
// DLL Entry Point

extern "C"
BOOL WINAPI DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID /*lpReserved*/)
{
   if( dwReason == DLL_PROCESS_ATTACH )
   {
      _Module.Init(ObjectMap, hInstance);
      ::DisableThreadLibraryCalls(hInstance);
   }
   if( dwReason == DLL_PROCESS_DETACH )
   {
      _Module.Term();
   }
   return TRUE;
}


/////////////////////////////////////////////////////////////////////////////
// Used to determine whether the DLL can be unloaded by OLE

STDAPI DllCanUnloadNow(void)
{
   return (_Module.GetLockCount() == 0) ? S_OK : S_FALSE;
}

/////////////////////////////////////////////////////////////////////////////
// Returns a class factory to create an object of the requested type

STDAPI DllGetClassObject(REFCLSID rclsid, REFIID riid, LPVOID* ppv)
{
   DRVTRACE(_T("DllGetClassObject\n"));
   return _Module.GetClassObject(rclsid, riid, ppv);
}

/////////////////////////////////////////////////////////////////////////////
// DllRegisterServer - Adds entries to the system registry

STDAPI DllRegisterServer(void)
{
   // Registers object, typelib and all interfaces in typelib
   return _Module.RegisterServer(FALSE);
}

/////////////////////////////////////////////////////////////////////////////
// DllUnregisterServer - Removes entries from the system registry

STDAPI DllUnregisterServer(void)
{
   return _Module.UnregisterServer(FALSE);
}

